HDU 3625 Examining the Rooms:第一类stirling数

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3625

题意:

  有n个房间,每个房间里放着一把钥匙,对应能开1到n号房间的门。

  除了1号门,你可以踹开任意一扇门(不用钥匙),但你最多只能踹k次。

  问你能将所有门打开的概率。

题解:

  · P(打开所有门) = 能打开所有门的钥匙放置情况数 / 钥匙放置的总情况数

  · 钥匙放置的总情况数 = n!

  

  那么考虑下能打开所有门的钥匙放置情况数。。。

  由于每个房间里有且只有一把钥匙,所以如果将每个房间连向房间内钥匙对应的房间,会得到一个有向图,并且由若干个独立的环组成。

  

  所以,只要将一个环内的任意一扇门踹开,就能打开这个环上的所有房间。

  如果不考虑1号门,那么要算的就是n个元素组成1~k个环排列的情况数。

  第一类Stirling数的定义啊!

  递推式:s(n,k) = s(n-1,k-1) + (n-1)*s(n-1,k)

  

  So...

  · 能打开所有门的钥匙放置情况数 = ∑S(n,i) (1<=i<=k)

  

  考虑到1号门不能踹,也就是1不能独立成环,它的情况数就等于用剩下n-1的元素组成i-1个环的情况数。

  · 能打开所有门的钥匙放置情况数 = ∑( S(n,i)-S(n-1,i-1) )

  所以答案为:∑( S(n,i)-S(n-1,i-1) ) / n!  (1<=i<=k)

AC Code:

 1 // s(n,k) = s(n-1,k-1) + (n-1)*s(n-1,k)
 2 // s(n,0) = 0    s(n,n) = 1
 3 // P = sigma(s[n][i]-s[n-1][i-1])/fact(n)    1<=i<=k
 4
 5 #include <iostream>
 6 #include <stdio.h>
 7 #include <string.h>
 8 #define MAX_N 25
 9 #define MAX_K 25
10
11 using namespace std;
12
13 int n,k,t;
14 long long sum;
15 long long s[MAX_N][MAX_K];
16 long long fact[MAX_N];
17
18 void stirling()
19 {
20     memset(s,0,sizeof(s));
21     for(int i=1;i<MAX_N;i++)
22     {
23         s[i][i]=1;
24         for(int j=1;j<i;j++)
25         {
26             s[i][j]=s[i-1][j-1]+(i-1)*s[i-1][j];
27         }
28     }
29 }
30
31 void cal_fact()
32 {
33     fact[0]=1;
34     for(int i=1;i<MAX_N;i++)
35     {
36         fact[i]=fact[i-1]*i;
37     }
38 }
39
40 int main()
41 {
42     stirling();
43     cal_fact();
44     cin>>t;
45     for(int cas=1;cas<=t;cas++)
46     {
47         cin>>n>>k;
48         sum=0;
49         for(int i=1;i<=k;i++)
50         {
51             sum+=s[n][i]-s[n-1][i-1];
52         }
53         printf("%.4f\n",(double)sum/fact[n]);
54     }
55 }
时间: 2024-10-11 08:18:31

HDU 3625 Examining the Rooms:第一类stirling数的相关文章

hdu 3625 Examining the Rooms —— 第一类斯特林数

题目:http://acm.hdu.edu.cn/showproblem.php?pid=3625 学习斯特林数:https://blog.csdn.net/qq_33229466/article/details/75042895 https://www.cnblogs.com/gzy-cjoier/p/8426987.html http://www.cnblogs.com/zhouzhendong/p/Stirling-Number.html 关于这道题: 得到一把钥匙后,可以连续开的门与钥匙

HDU 3625 Examining the Rooms 第一类斯特林数

最多可以暴力打开k次 对于一个环暴力一次 n个数排成i个(i<=k)非空环排列的种数 另外第一扇门不能暴力打开 所以1不能独立成环 #include <cstdio> #include <cstring> using namespace std; typedef __int64 LL; LL dp[22][22]; LL f[22]; int main() { dp[0][0] = 1; f[0] = 1; for(int i = 1; i <= 20; i++) {

HDU3265 Examining the Rooms【stirling数】

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=3625 题目大意: 有N个房间,每个房间的要是随机放在某个房间内,概率相同.有K次炸门的机会. 求能打开所有房间门,进入所有房间的概率有多大. 解题思路: 门和钥匙的对应关系出现环.打开一个门后,环内的门都可以打开.也就意味着: N个房间的钥匙与门形成1~K个环的概率有多大. 也就是求N个元素,构成K个以内的环,且1不成自环的概率. N个元素形成K个环的方法数是第一类stirling数 S(N,K)

HDU 3625 Examining the Rooms(第一类斯特林数)

题意:给你n扇门,然后可以开k次门,每次们后都有一把钥匙,不能开1号门,问最后打开一号门的概率是多少 思路:看大家说是裸的第一类斯特林数,我觉得有篇博客写的很好(传送门),这里采取的是博客里的第二种思路,感觉这种如果想到的话更容易理解,但是并没有遇到博客里说的g++会wa的情况 代码: #include <bits/stdc++.h> using namespace std; typedef long long LL; const int maxn=55; LL s1[maxn][maxn];

HDU 3625 Examining the Rooms

Problem Description A murder happened in the hotel. As the best detective in the town, you should examine all the N rooms of the hotel immediately. However, all the doors of the rooms are locked, and the keys are just locked in the rooms, what a trap

HDU 4372 Count the Buildings:第一类Stirling数

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4372 题意: 有n栋高楼横着排成一排,各自的高度为1到n的一个排列. 从左边看可以看到f栋楼,从右边看可以看到b栋楼,并且高的楼会挡住低的楼. 问你这些楼有多少种排列方法. 题解: 由于高的楼会挡住低的楼,所以这些楼首先会被划分成f+b-2个区域(除去中间最高的楼),并且左边有f-1个,右边有b-1个. 对于一个区域(假设在左边),这个区域由若干栋楼组成,并且最高的楼一定在最左边. 那么,由一个区域

hdu 4372 第一类stirling数的应用/。。。好题

1 /** 2 大意: 给定一系列楼房,都在一条水平线上,高度从1到n,从左侧看能看到f个, 从右侧看,能看到b个,问有多少种这样的序列.. 3 思路: 因为肯定能看到最高的,,那我们先假定最高的楼房位置确定,那么在其左边还有f-1个能看见,在其右边还有b-1个,能看见..所以可以这样将题目转化: 将除最高楼之外的n-1个楼,分成f-1+b-1 组,在最高楼左边f-1 组,在其右边b-1组,那么分成f-1+b-1 组 就是第一类Stirling数.s[n-1][f-1+b-1]..左边f-1 组

HDU4372-Count the Buildings(第一类Stirling数+组合计数)

Count the Buildings Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 528    Accepted Submission(s): 171 Problem Description There are N buildings standing in a straight line in the City, numbere

Luogu4609 FJOI2016 建筑师 第一类Stirling数

题目传送门 题意:给出$N$个高度从$1$到$N$的建筑,问有多少种从左往右摆放这些建筑的方法,使得从左往右看能看到$A$个建筑,从右往左看能看到$B$个建筑.$N \leq 5 \times 10^4 , A,B \leq 100$ 第一次看到第一类$Stirling$数有用emmm 考虑将某种方案中最高的建筑拿出来,将分成的两半中可以看得见的与被它挡住的建筑分成一个部分,如下 绿色的当然是最高的,剩下的两个部分分成了1,2,3三个部分.可以知道我们总共需要$A+B-2$这样的部分,而其中$A